Index: common/libmondo-raid.c
===================================================================
RCS file: /var/lib/cvs/UO/mondorescue/mondo/src/common/libmondo-raid.c,v
retrieving revision 1.1.1.1
diff -u -p -b -u -r1.1.1.1 libmondo-raid.c
--- common/libmondo-raid.c	28 Feb 2007 11:41:57 -0000	1.1.1.1
+++ common/libmondo-raid.c	6 Apr 2007 15:45:21 -0000
@@ -427,7 +427,7 @@ void save_raidrec_to_file(struct
 int get_next_raidtab_line(FILE * fin, char *label, char *value)
 {
 	char *incoming;
-	char *p;
+	char *p, *p2;
 
 	malloc_string(incoming);
 	assert(fin != NULL);
@@ -441,17 +441,25 @@ int get_next_raidtab_line(FILE * fin, ch
 	}
 	for (fgets(incoming, MAX_STR_LEN - 1, fin); !feof(fin);
 		 fgets(incoming, MAX_STR_LEN - 1, fin)) {
-		strip_spaces(incoming);
-		p = strchr(incoming, ' ');
-		if (strlen(incoming) < 3 || incoming[0] == '#' || !p) {
+		p = incoming;
+		while (isspace(*p) && *p) p++;
+		if (strlen(p) < 3 || *p == '#' || !(*p)) {
 			continue;
 		}
-		*(p++) = '\0';
-		while (*p == ' ') {
-			p++;
-		}
-		strcpy(label, incoming);
-		strcpy(value, p);
+		p2 = p;
+		while (!isspace(*p2) && *p2) p2++;
+		strncpy(label, p, p2 - p);
+		label[p2-p] = 0;
+		mr_msg(3, "label is %s, rest is %s, p2 is %s", label, p, p2);
+
+		while (isspace(*p2) && *p2) p2++;
+		p = p2;
+
+		while (!isspace(*p2) && *p2) p2++;
+		strncpy(value, p, p2 - p);
+		value[p2-p] = 0;
+		mr_msg(3, "value is %s, rest is %s", value, p);
+
 		mr_free(incoming);
 		return (0);
 	}
@@ -1016,6 +1024,11 @@ int parse_mdstat(struct raidlist_itself 
       raidlist->entries++;
       raidlist->el[raidlist->entries].progress = 999;
     } else {
+	  if (row == 4) {
+	      row = 1;
+	      raidlist->entries++;
+	      raidlist->el[raidlist->entries].progress = 999;
+	  }
       switch (row) {
       case 1:  // device information
 	// check whether last line of record and if so skip
